<?php
/**
 * class for birthdate plugins
 *
 * @package	VirtueMart
 * @subpackage Userfield Plugin
 * @author ConseilGouz
 * @link http://www.conseilgouz.com
 * @copyright (c) 2016 ConseilGouz. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 01.00.00 / 2016-08-25
 */

// Get the plugin library
jimport('joomla.plugin.plugin');
if (!class_exists('vmUserfieldPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmuserfieldtypeplugin.php');
}

class plgVmUserfieldBirthdate extends vmUserfieldPlugin {	
	public $params = null;
	var $plg_config=array();
	/*
		Constructor
	 */
	function __construct(& $subject, $config)
	{ 
		$this->plg_config = json_decode($config['params']); // sauve paramtres
		parent::__construct($subject, $config);
	}
	/*
		Contrle des zones avant sauvegarde
	*/
	public function plgVmOnBeforeUserfieldDataSave (&$valid,$id,&$data,$user) {
	
		    $adulte = $this->plg_config->vmshoppersgroup;
		    if (is_null($adulte)) { // shoppersgroup adulte non dfini
		    	vmError('Plugin BirthDate: Groupe non defini','Plugin BirthDate: Groupe non defini' );
		    	$noError = false;
				$valid = false;
		    	return false;	
		    }
			if (!(isset($data['birthdate']))) { // zone birthdate non dfinie
		    	vmError('Plugin BirthDate: zone birthdate non definie','Plugin BirthDate: zone birthdate non definie' );
		    	$noError = false;
				$valid = false;
		    	return false;	
			}
	 		$date = new JDate($data['birthdate']);
	 		$this->date = $date->format('Y-m-d H:i:s');
	 		$vide = new JDate('0');
	 		if ($this->date  == $vide->format('Y-m-d H:i:s')) {
		    	vmError('Plugin BirthDate: Date de naissance incorrecte ou vide','Plugin BirthDate: Date de naissance incorrecte ou vide' );
		    	$noError = false;
				$valid = false;
	 			return false; // date vide => erreur
	 		}	
	}
	/*
		Stockage des informations si majeur
	*/
	public function plgVmOnUserStore(&$data) {
		    $adulte = $this->plg_config->vmshoppersgroup;
	 		$date = new JDate($data['birthdate']);
	 		$this->date = $date->format('Y-m-d H:i:s');
	 		$mineur = new JDate('now -18 year'); // date du jour moins 18 ans
	 		if ($this->date  > $mineur->format('Y-m-d H:m:s')) {
	 			return true; // mineur : on ne fait rien
	 		}
	 		if (isset($data['virtuemart_shoppergroup_id'])) {
			// la table shopergroup existe
	 			if (in_array($adulte,$data['virtuemart_shoppergroup_id'])) {
	 				return true; // on a deja la valeur dans la table
	 			}
	 			$data['virtuemart_shoppergroup_id'][] = $adulte;
	 		}
	 		else {
		    // elle n'existe pas: on la cre
	 			$data['virtuemart_shoppergroup_id'] = array();
	 			$data['virtuemart_shoppergroup_id'][] = $adulte;
	 		}
			$this->store_shoppersgroup($data); // ecriture dans la base de donnes
			return true;
	}
	/* 
		Ecriture des informations dans la table vmuser_shoppergroups 
	*/
	private function store_shoppersgroup($data) {

			$shoppergroupData = array('virtuemart_user_id'=>$data['virtuemart_user_id'],'virtuemart_shoppergroup_id'=>$data['virtuemart_shoppergroup_id']);
			$user_model = VmModel::getModel('User');
			$user_shoppergroups_table = $user_model->getTable('vmuser_shoppergroups');
			$res = $user_shoppergroups_table -> bindChecknStore($shoppergroupData);
			if(!$res){
				vmError('Set shoppergroup error');
				$noError = false;
			}

	}
}
